//+------------------------------------------------------------------+
//|                                           Phase Change Index.mq4 |
//|                                                           mladen |
//|                                                                  |
//| Phase Change Index originaly developed by M.H. Pee               |
//| TASC : 22:05 (May 2004) article                                  |
//| "Waxing And Waning. Phase Change Index"                          |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_separate_window
#property indicator_buffers    1
#property indicator_color1     DarkOrange
#property indicator_levelcolor DimGray
#property indicator_minimum  -1
#property indicator_maximum 101


//
//
//
//
//

extern int    Length    = 35;
extern int    Price     = PRICE_CLOSE;
extern double LevelHigh = 80;
extern double LevelLow  = 20;

//
//
//
//
//

double Pci[];
double prices[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,Pci);  SetIndexLabel(0,"Phase Change Index");
   
      //
      //
      //
      //
      //
      
      LevelHigh = MathMin(MathMax(LevelHigh,0),100);
      LevelLow  = MathMin(MathMax(LevelLow,0) ,100);
      if (LevelHigh<LevelLow)
         {
            double temp = LevelHigh;
                   LevelHigh = LevelLow;
                   LevelLow  = temp;
         }
         
      //
      //
      //
      //
      //
               
   SetLevelValue(0,LevelHigh);
   SetLevelValue(1,LevelLow);
   return(0);
}
int deinit()
{
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,r,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-Length);
         if (ArrayRange(prices,0) != Bars) ArrayResize(prices,Bars);

   //
   //
   //
   //
   //

   for(i=limit, r=Bars-limit-1; i>=0; i--,r++)
   {
      prices[r] = iMA(NULL,0,1,0,MODE_SMA,Price,i);

      //
      //
      //
      //
      //

      double momentum = prices[r]-prices[r-Length];
      double sumUpDi  = 0;
      double sumDnDi  = 0;
      for(int j=1; j<Length; j++)
      {
         double gradient  = prices[r-Length]+momentum*(Length-j)/(Length);
         double deviation = prices[r-j]-gradient;
            if (deviation > 0)
                  sumUpDi += deviation;
            else  sumDnDi -= deviation;
      }               
            
      //
      //
      //
      //
      //

      if ((sumUpDi+sumDnDi)!=0)
            Pci[i] = 100.0*sumUpDi/(sumUpDi+sumDnDi);
      else  Pci[i] = 0; 
   }
   return(0);
}